import os
import re
import json

CRAWLERS = {}
ua_path = os.path.dirname(os.path.abspath(__file__))

with open(ua_path + '/crawler-user-agents.json', encoding='utf-8') as json_file:
    CRAWLERS = json.load(json_file)

class CrawlerAgentObject:
    def __init__(self, crawler):
        self.__dict__ = crawler
        self.name_clean = self.name.lower()

class CrawlerAgent:
    def __init__(self):
        #self.patterns = [p['pattern'] for p in CRAWLERS]
        patterns = [p['pattern'] for p in CRAWLERS]
        self.re_patterns = re.compile(r'(%s)' % '|'.join(patterns))

    def match(self, user_agent):
        for c in CRAWLERS:
            rep = re.compile(r'%s' % c['pattern'])
            bot = rep.search(user_agent)
            if bot:
                return CrawlerAgentObject(c)



# TESTING
if __name__ == '__main__':
    ca = CrawlerAgent()

    r = ca.match("Mozilla/5.0 (Linux; Android 6.0.1; Nexus 5X Build/MMB29P) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/96.0.4664.45 Mobile Safari/537.36 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)")
    print(r)

    print(r.name)

    import sys
#    sys.exit()
    with open('./test-ua', encoding='utf-8') as p:
        for pattern in p:
            r = ca.match(pattern.strip()) 
#            if r:
#                print(r.name_clean)
